<?php

   /*
   Copyright (C) 2001
   by Justin Woods <woodsj@swau.edu>
   and David Sowder <davids@swau.edu>
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   */

   // $Id: index.php,v 1.38 2001/08/08 22:04:20 davids Exp $

   // Check the PHP version before doing anything else
   // The check seems to have to be here because webstamp.inc doesn't parse
   // under the PHP 3.x that I've tried it with
   if( floor( phpversion()) != 4 ) {
     echo "<html>\n";
     echo "<head>\n";
     echo "<title>Webstamp error</title>\n";
     echo "</head>\n";
     echo "<body bgcolor=\"#ffffff\">\n";
     echo "<center><font size=+3 color=\"#ff0000\">Webstamp error</font></center><br>\n";
     echo "The Webstamp framework currently requires PHP version 4.x<br><br>\n";
     echo "You shouldn't see this message unless you're a Webstamp website developer.<br><br>\n";
     echo "Please notify the server administrator: $SERVER_ADMIN\n";
     echo "</body>\n";
     echo "</html>\n";
     die();
     }

   // Required variable "setup" is below
   if( is_link( readlink( $SCRIPT_FILENAME ))) {
     if( is_link( readlink( readlink( $SCRIPT_FILENAME )))) {
       // **FIXME**
       echo "<html><head><title>Oops</title></head><body bgcolor=\"#ffffff\">\n
             We made a silly error somewhere and now our site is broken.<br>\n
             Perhaps you can at least get somewhere useful from the\n
             \"<a href=\"/\">Front Door</a>\"<br>\n
             <br>\n
             <p><i>url: $REQUEST_URI</i></p>\n";
       die( '' );
       }
     $OURLIBS = dirname( readlink( $SCRIPT_FILENAME ));
     if( !strcmp( dirname( $OURLIBS ), '' )) {
       $ROOTLIBS = dirname( dirname( dirname( readlink( readlink( $SCRIPT_FILENAME ))))) . '/.libs';
       }
     else {
       $ROOTLIBS = dirname( $OURLIBS) . '/' . dirname( dirname( dirname( readlink( readlink( $SCRIPT_FILENAME ))))) . '/.libs';
       }
     }
   else {
     $OURLIBS = dirname( readlink( $SCRIPT_FILENAME ));
     $ROOTLIBS = $OURLIBS;
     }
   if( !strncmp( $OURLIBS, './', 2 )) {
     $OURLIBS = substr( $OURLIBS, 2 );
     }
   if( !strncmp( $ROOTLIBS, './', 2 )) {
     $ROOTLIBS = substr( $ROOTLIBS, 2 );
     }
   if( !strcmp( dirname( $OURLIBS ), '' )) {
     $OURGFX = '.gfx';
     }
   else {
     $OURGFX = dirname( $OURLIBS ) . '/.gfx';
     }
   if( !strcmp( dirname( $ROOTLIBS ), '' )) {
     $ROOTGFX = '.gfx';
     }
   else {
     $ROOTGFX = dirname( $ROOTLIBS ) . '/.gfx';
     }
   if( !strncmp( $OURGFX, './', 2 )) {
     $OURGFX = substr( $OURGFX, 2 );
     }
   if( !strncmp( $ROOTGFX, './', 2 )) {
     $ROOTGFX = substr( $ROOTGFX, 2 );
     }
   include( $ROOTLIBS . '/webstamp.inc' );  // get_gfx_match_url() needed next
   $pos = strrpos( $REQUEST_URI, '?' );
   if( $pos > 0 ) {
     $CLEANER_URI = substr( $REQUEST_URI, 0, $pos );
     }
   else {
     $CLEANER_URI = $REQUEST_URI;
     }
   $pos = strrpos( $CLEANER_URI, '/' );
   if( $pos > 0 ) {
     $CLEANED_URI = substr( $CLEANER_URI, 0, $pos + 1 );
     }
   else {
     $CLEANED_URI = $CLEANER_URI;
     }
   $OURURL = get_gfx_matched_url( dirname( $OURLIBS ), $CLEANED_URI );
   $ROOTURL = get_gfx_matched_url( dirname( $ROOTLIBS ), $CLEANED_URI );
   if( !strncmp( $OURURL, '//', 2 )) {
     $OURURL = substr( $OURURL, 1 );
     }
   if( !strncmp( $ROOTURL, '//', 2 )) {
     $ROOTURL = substr( $ROOTURL, 1 );
     }
   $OURGFXURL = $OURURL . '.gfx/';
   $ROOTGFXURL = $ROOTURL . '.gfx/';
   $THISURL = $CLEANED_URI;

   include( "${ROOTLIBS}/siteconfig.inc" );

   //
   // Required variable "setup" is above
   // Page begins here
   //



// *************************************

   $dir_list = get_directory_steps_to_libs_dir($SCRIPT_FILENAME);

   $workingset = implode( '', file( "${OURLIBS}/^MAIN" ));

   while( list($k, $dir) = each($dir_list) ) {
      $workingset = process( $OURLIBS, $dir, $workingset, '^' );
   }
   $workingset = process( $OURLIBS, dirname($SCRIPT_FILENAME), $workingset );

   if( !isset( $unknowns )) {
     $unknowns='remove';
     }
   switch ($unknowns) {
     case "keep":
       break;
     case "remove":
       $workingset = preg_replace("/\{[^}]+\}/", "", $workingset);
       break;
     case "comment":
       $workingset = preg_replace("/\{([^}]+)\}/", "<!-- Template $varname: Variable \\1 undefined -->", $workingset);
       break;
     }

   if( $encoding = gzip_accepted($HTTP_ACCEPT_ENCODING) && $USE_COMPRESSION) {
      $gzdata = '\x1f\x8b\x08\x00\x00\x00\x00\x00'; // gzip header
      $size = strlen($workingset);
      $crc = crc32($workingset);
      $gzdata .= gzcompress($workingset, 9);
      $gzdata = substr($gzdata, 0, strlen($gzdata) - 4); // fix crc bug
      $gzdata .= pack('V',$crc) . pack('V', $size);

      Header('Content-Encoding: ' . $encoding );
      Header('Content-Length: ' . strlen($gzdata));
      echo $gzdata;
   }
   else {
      echo $workingset;
   }

?>